<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><title>TODOs • rdb</title><script src="lightswitch.js"></script><script src="deps/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"><link href="deps/bootstrap-5.3.1/bootstrap.min.css" rel="stylesheet"><script src="deps/bootstrap-5.3.1/bootstrap.bundle.min.js"></script><link href="deps/font-awesome-6.5.2/css/all.min.css" rel="stylesheet"><link href="deps/font-awesome-6.5.2/css/v4-shims.min.css" rel="stylesheet"><script src="deps/headroom-0.11.0/headroom.min.js"></script><script src="deps/headroom-0.11.0/jQuery.headroom.min.js"></script><script src="deps/bootstrap-toc-1.0.1/bootstrap-toc.min.js"></script><script src="deps/clipboard.js-2.0.11/clipboard.min.js"></script><script src="deps/search-1.0.0/autocomplete.jquery.min.js"></script><script src="deps/search-1.0.0/fuse.min.js"></script><script src="deps/search-1.0.0/mark.min.js"></script><!-- pkgdown --><script src="pkgdown.js"></script><meta property="og:title" content="TODOs"><meta name="twitter:card" content="summary"><meta name="twitter:creator" content="@2BSalim"><meta name="twitter:site" content="@2BSalim"><meta name="robots" content="noindex"><script src="https://rpkg.dev/counter-dev.min.js" data-id="4c4963fe-9fcf-4d81-95bb-2135e114b85b" data-utcoffset="1"></script></head><body>
    <a href="#main" class="visually-hidden-focusable">Skip to contents</a>


    <nav class="navbar navbar-expand-lg fixed-top " aria-label="Site navigation"><div class="container">

    <a class="navbar-brand me-2" href="index.html">rdb</a>

    <small class="nav-text text-danger me-auto" data-bs-toggle="tooltip" data-bs-placement="bottom" title="In-development version">0.0.9046</small>


    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div id="navbar" class="collapse navbar-collapse ms-3">
      <ul class="navbar-nav me-auto"><li class="nav-item"><a class="nav-link" href="articles/rdb.html">Get started</a></li>
<li class="nav-item"><a class="nav-link" href="reference/index.html">Reference</a></li>
<li class="nav-item"><a class="nav-link" href="articles/codebook.html">RDB codebook</a></li>
      </ul><ul class="navbar-nav"><li class="nav-item"><form class="form-inline" role="search">
 <input class="form-control" type="search" name="search-input" id="search-input" autocomplete="off" aria-label="Search site" placeholder="Search for" data-search-index="search.json"></form></li>
<li class="nav-item"><a class="external-link nav-link" href="https://gitlab.com/zdaarau/rpkgs/rdb/" aria-label="GitLab"><span class="fa fab fa-gitlab fa-lg"></span></a></li>
<li class="nav-item dropdown">
  <button class="nav-link dropdown-toggle" type="button" id="dropdown-lightswitch" data-bs-toggle="dropdown" aria-expanded="false" aria-haspopup="true" aria-label="Light switch"><span class="fa fa-sun"></span></button>
  <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="dropdown-lightswitch"><li><button class="dropdown-item" data-bs-theme-value="light"><span class="fa fa-sun"></span> Light</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="dark"><span class="fa fa-moon"></span> Dark</button></li>
    <li><button class="dropdown-item" data-bs-theme-value="auto"><span class="fa fa-adjust"></span> Auto</button></li>
  </ul></li>
      </ul></div>


  </div>
</nav><div class="container template-title-body">
<div class="row">
  <main id="main" class="col-md-9"><div class="page-header">

      <h1>TODOs</h1>
      <small class="dont-index">Source: <a href="https://gitlab.com/zdaarau/rpkgs/rdb/blob/HEAD/TODO.md" class="external-link"><code>TODO.md</code></a></small>
    </div>

<div id="todos" class="section level1">

<div class="section level2">
<h2 id="rebranding">Rebranding<a class="anchor" aria-label="anchor" href="#rebranding"></a></h2>
<ul><li>Once we finished rebranding, we should add a Wikipedia article (DE and EN) and point the acronym “fork” articles <a href="https://de.wikipedia.org/wiki/RDB" class="external-link">RDB (de)</a> and <a href="https://en.wikipedia.org/wiki/RDB" class="external-link">RDB (en)</a> to it.</li>
</ul></div>
<div class="section level2">
<h2 id="to-be-discussed---convert-to-gitlab-issues-adding-an-additional-to-be-discussed-label">To be discussed (-&gt; convert to GitLab issues (adding an additional <code>to be discussed</code> label)!)<a class="anchor" aria-label="anchor" href="#to-be-discussed---convert-to-gitlab-issues-adding-an-additional-to-be-discussed-label"></a></h2>
<ul><li><p><a href="https://hackmd.io/fqOb9I04RLiDI5wm9-VR6Q" class="external-link">New data schema</a>.</p></li>
<li><p>Experiment with <code>plotly::plot_ly(colors = viridis::turbo(n = ?))</code> in <code><a href="reference/plot_topic_segmentation.html">plot_topic_segmentation()</a></code></p></li>
<li><p>There is at least one “Landsgemeinde” referendum (<code>id = 5bbc004292a21351232e52e7</code>) with no result (<code>NA</code>) where the result should actually be <code>"no"</code> (Landsgemeinde rejected proposal) if I’m not mistaken. Do we handle “Landsgemeinde” votes specially or why is that?</p></li>
<li><p>Should we also try to collect “surrounding conditions” information besides the formal institutional stuff? For example, international law recognizes a <a href="https://specials.dekoder.org/faq-schein-referendum-donezk-luhansk-cherson-saporishshja#q2" class="external-link">set of conditions that must be met for a secession referendum to be considered legal</a>.</p></li>
<li>
<p>Add additional database fields:</p>
<ul><li>
<code>description</code>, holding a short prosa description of the referendum.</li>
<li>
<code>tags</code> (maybe we’ll find a better name, e.g. <code>keywords</code>?), holding a list of freely definable tags, so we can create ad-hoc collections of referendums that share some common characteristic</li>
<li>
<code>status</code> to capture the recognition status of a voting</li>
</ul><p>Any more?</p>
</li>
<li>
<p>According to Uwe, we only capture “official”/“authorized” votings, but there are already inofficial ones present in the database like <a href="https://c2d.ch/referendum/HU/5bbbfee992a21351232e4f37" class="external-link">this one</a> for which sudd.ch <a href="https://sudd.ch/event.php?id=hu042008" class="external-link">reports</a>:</p>
<blockquote>
<p>Diese Abstimmung ist nicht offiziell und wird von niemandem anerkannt.</p>
</blockquote>
<p>Instead of not capturing such votings, it would be superior to introduce another variable indicating the status of a voting (official, inofficial, …); currently we only have an <em>institutional</em> variable <code>legal_basis_type</code> (formerly <code>official_status</code>) which measures a completely different thing. Maybe name this new variable simply <code>status</code>?</p>
</li>
<li>
<p>Völkerrechtlich umstrittene Gebiete: Es gibt bislang keine explizite RDB-Policy dazu, wir müssten daher etwas definieren.</p>
<p>Bspw. werden</p>
<ul><li>alle Abstimmungen, die die <a href="https://de.wikipedia.org/wiki/Kosovo" class="external-link">Republik Kosovo</a> betreffen, unter dem <code>country_name</code> <em>Serbia</em> geführt…</li>
<li>für die Abstimmungen in Taiwan uneinheitliche <code>country_name</code>’s verwendet, für die Abstimmungen am 2018-11-24 <em>Taiwan, Province of China</em>, für die anderen einfach <em>Taiwan</em>…</li>
</ul><p>Pragmatisch wäre, einfach die Handhabung der offiziellen/diplomatischen Schweiz zu übernehmen.</p>
</li>
<li>
<p>There is obviously not much consistency in how the referendum titles in the three languages are captured. According to the guidelines to add Swiss votings (<code>~/Arbeit/ZDA/Lokal/RDB/Materialen von Mayowa/CH_Vorgehen_Abstimmungseingabe.docx</code>), the <code>title_de</code> (and <code>title_fr</code> if one exists) are the official titles by the authorities and <code>title_en</code> is a translation of the German one. But</p>
<ul><li>the Swiss authorities (sometimes) also translate the title to English themselves (<a href="https://www.admin.ch/gov/en/start/documentation/votes/20181125/horned-cow-initiative.html" class="external-link">example</a>).</li>
<li>the guidelines to add international votings (<code>~/Arbeit/ZDA/Lokal/RDB/Materialen von Mayowa/Intl_Vorgehen_Abstimmungseingabe.docx</code>) don’t say anything about the titles; but sometimes there’s a German title for countries where almost certainly no official German version exists (e.g. Venezuela).</li>
</ul><p>Therefore, we should define a better/stricter policy how titles are captured (and identify existing entries violating this policy, so they can be corrected).</p>
</li>
<li>
<p>Topics-Hierarchie anpassen:</p>
<ul><li>den <code>topic_tier_3</code> “homosexuals” wohl etwas breiter fassen, bspw. “sexual orientation / gender identity”.</li>
<li>den <code>topic_tier_3</code> “compensation for loss of earnings for persons on military service or civil protection duty” kürzen!</li>
</ul><p>Sonstige Vorschläge?</p>
</li>
</ul></div>
<div class="section level2">
<h2 id="ideas---convert-to-gitlab-issues-adding-an-additional-ideas-label">Ideas (-&gt; convert to GitLab issues (adding an additional <code>ideas</code> label)!)<a class="anchor" aria-label="anchor" href="#ideas---convert-to-gitlab-issues-adding-an-additional-ideas-label"></a></h2>
<ul><li>
<p>We should ensure minimum quality of attachments (e.g. correct orientation, page ordering, OCR). Bad example: <a href="https://services.c2d.ch/s3_objects/referendum_5bbbf59192a21351232e2e65_0001.pdf" class="external-link uri">https://services.c2d.ch/s3_objects/referendum_5bbbf59192a21351232e2e65_0001.pdf</a></p>
<p>I could probably write some validation fn in pkg rdb that checks all PDFs for text content to determine if they’re OCR’ed, but maybe there’s already more sophisticated software available for this.</p>
<p>Ideally, the data portal should ensure the minimum quality requirements upon upload and display an informative warning in case of violation (with an opt-in override to upload nevertheless).</p>
</li>
</ul></div>
<div class="section level2">
<h2 id="rdb-r-package">rdb R package<a class="anchor" aria-label="anchor" href="#rdb-r-package"></a></h2>
<ul><li><p>Prefix all Plotly fns with <code>plotly_</code> instead of <code>plot_</code> to avoid misconceptions.</p></li>
<li>
<p>Adapt code to use NocoDB’s API instead of <code>services.c2d.ch</code> after we finished basic transition to NocoDB.</p>
<p>We should probably either use</p>
<ul><li>the R package <a href="https://github.com/bergant/rapiclient" class="external-link">rapiclient</a> which can automatically extract the relevant specs from the OpenAPI definition, or</li>
<li>the <a href="https://openapi-generator.tech/" class="external-link">OpenAPI Generator</a> which apparently can <a href="https://community.rstudio.com/t/generate-rest-api-clients-in-r-using-openapi-generator/141374" class="external-link">generate a ready-made R package from an OpenAPI definition</a> (see also <a href="https://community.rstudio.com/t/anyone-using-openapi-generator-to-generate-r-packages/94486" class="external-link">this post</a>).</li>
</ul></li>
<li><p>Automated vote entry creation by feeding scraped sudd.ch data to <code><a href="reference/add_rfrnds.html">rdb::add_rfrnds()</a></code>.</p></li>
<li>
<p>For meaningful cross-time analyses, we need additional information about countries (“jurisdictions”):</p>
<ul><li>
<p>Information about <em>territorial</em> changes. This is (at least for the most essential part) covered by our current ISO 3166-based country classification.</p>
<p>TODO: Investigate whether additional information could be sourced from the <a href="https://en.wikipedia.org/wiki/Correlates_of_War" class="external-link">Correlates of War</a> project’s <a href="https://correlatesofwar.org/data-sets/territorial-change/" class="external-link">Territorial Change</a> dataset.</p>
</li>
<li>
<p>Information about <em>political/jurisdictional</em> changes. Currently we don’t cover this beyond ISO 3166. <a href="https://en.wikipedia.org/wiki/ISO_3166-1_numeric" class="external-link">ISO 3166-1 <em>numeric</em></a> does indirectly cover those political changes which are also accompanied by territorial changes, but no intra-territorial changes.</p>
<p>Consider for example the country <em>Lybia</em> (<code>LY</code>) which already experienced 4 major political systems which are not reflected in ISO 3166:</p>
<ul><li><a href="https://en.wikipedia.org/wiki/Kingdom_of_Libya" class="external-link">(United) Kingdom of Libya (1951–1969)</a></li>
<li><a href="https://en.wikipedia.org/wiki/History_of_Libya_under_Muammar_Gaddafi#Libyan_Arab_Republic_(1969%E2%80%931977)" class="external-link">Libyan Arab Republic (1969–1977)</a></li>
<li><a href="https://en.wikipedia.org/wiki/History_of_Libya_under_Muammar_Gaddafi#Great_Socialist_People's_Libyan_Arab_Jamahiriya_(1977%E2%80%932011)" class="external-link">Great Socialist People’s Libyan Arab Jamahiriya (1977–2011)</a></li>
<li><a href="https://en.wikipedia.org/wiki/National_Transitional_Council" class="external-link">National Transitional Council of Libya (2011–2012) / Libya (2012–)</a></li>
</ul><p>Viable sources for political/jurisdictional changes of countries include:</p>
<ul><li>Wikidata</li>
</ul></li>
<li>
<p>Information about <em>(in)dependency</em> status of geographical entities on the <em>national</em> level (i.e. “countries”). Currently, we treat <em>external</em> <a href="https://en.wikipedia.org/wiki/Dependent_territory" class="external-link">dependent territories</a> like <a href="https://en.wikipedia.org/wiki/Norfolk_Island" class="external-link">Norfolk Island</a> (an external territory of Australia) the same as fully independent countries like Switzerland.</p>
<p>Ideally, we’d augment our data with an additional variable from a suitable external source that holds information about a country’s (in)dependency status. See <a href="https://en.wikipedia.org/wiki/Dependent_territory" class="external-link">this Wikipedia article</a> for an overview. Maybe we could source the information from Wikidata?</p>
</li>
</ul></li>
</ul></div>
<div class="section level2">
<h2 id="other">Other<a class="anchor" aria-label="anchor" href="#other"></a></h2>
<ul><li><p>Add terminology reference complementing other structure information like the RDB codebook. E.g. we often use the term “voting” to refer to a referendum instance but we don’t have a formal lookup reference for these kind of things.</p></li>
<li><p>Are <code>id_sudd</code>s stable over time? Maybe contact the creator <a href="mailto:beat@sudd.ch">Beat Müller</a> and ask?</p></li>
<li><p>Genauer abklären, inwieweit man Angaben von Swissvotes integrieren oder linken könnte. Evtl. Techniker hinter Swissvotes kontaktieren, um herauszufinden, mit welchen Weiterentwicklungen zu rechnen ist (Stichwort: API!); ein Blick in den Quellcode des <a href="https://politanch.github.io/swissdd/" class="external-link">swissdd</a>-R-Pakets könnte womöglich ganz aufschlussreich sein!</p></li>
</ul></div>
<div class="section level2">
<h2 id="internal-at-least-for-now">Internal (at least for now)<a class="anchor" aria-label="anchor" href="#internal-at-least-for-now"></a></h2>
<div class="section level3">
<h3 id="content">Content<a class="anchor" aria-label="anchor" href="#content"></a></h3>
<div class="section level4">
<h4 id="an-mayowa-delegiert">An Mayowa delegiert<a class="anchor" aria-label="anchor" href="#an-mayowa-delegiert"></a></h4>
<ul><li>
<p>Bei verschiedenen Abstimmungen meldet sudd.ch</p>
<blockquote>
<p>“id=…” ist gelöscht , weil keine Volksabstimmung stattgefunden hat.</p>
</blockquote>
<p>Betroffen sind die folgenden Abstimmungen:</p>
<ul><li>
<a href="https://sudd.ch/event.php?id=eg011976" class="external-link">Ägypten 1976-06-10</a>; bei uns: <a href="https://admin.c2d.ch/referendum/5bbbe82f92a21351232e0381" class="external-link">5bbbe82f92a21351232e0381</a>
</li>
<li>
<a href="https://sudd.ch/event.php?id=nz011931" class="external-link">New Zealand 1931-12-02</a>; bei uns 3 Einträge, jeweils einer pro Option: <a href="https://admin.c2d.ch/referendum/5bbbe29792a21351232de3c9" class="external-link">5bbbe29792a21351232de3c9</a>, <a href="https://admin.c2d.ch/referendum/5bbbe29792a21351232de3c7" class="external-link">5bbbe29792a21351232de3c7</a>, <a href="https://admin.c2d.ch/referendum/5bbbe29792a21351232de3c7" class="external-link">5bbbe29792a21351232de3c7</a>
</li>
<li>
<a href="https://sudd.ch/event.php?lang=de&amp;id=pr041952" class="external-link">Puerto Rico 1952-11-04 (3. Abstimmungsvorlage “Abolition of certain social rights”)</a>, bei uns: <a href="https://admin.c2d.ch/referendum/5bbbe2ba92a21351232ded1f" class="external-link">5bbbe2ba92a21351232ded1f</a>
</li>
</ul><p>Falls in diesen Fällen tatsächlich keine Abstimmungen stattfanden, sollten die Einträge aus der RDB entfernt werden!</p>
</li>
<li><p>Bei der <a href="https://admin.c2d.ch/referendum/5bbbeaee92a21351232e0ca5" class="external-link">Abstimmung Norfolk Island 1980-07-10</a> meint sudd.ch, sie habe stattdessen <a href="https://sudd.ch/event.php?lang=de&amp;id=nf011979" class="external-link">1979-07-10 stattgefunden</a>. Falls sudd.ch Recht hat, sollte das korrigiert werden.</p></li>
<li>
<p><a href="https://link.springer.com/content/pdf/10.1057/s41304-019-00230-4.pdf" class="external-link">Silagadze &amp; Gherghina (2019)</a> (S. 467) detected some referendums that are missing in the database -&gt; systematically check/add these!</p>
<p>They include Italy <del>1929</del> and 1934, <del>Andorra 1933</del>, <del>Austria 1938</del>, Romania 2009, <del>Slovenia 2015</del>, <del>Bulgaria 2016</del>, <del>Netherlands 2016</del>, <del>UK 2016</del>.</p>
</li>
</ul></div>
<div class="section level4">
<h4 id="other-1">Other<a class="anchor" aria-label="anchor" href="#other-1"></a></h4>
<ul><li><p>A total of 858 referendums don’t have a <code>type</code> set though it’s a mandatory field (at least in the C2D admin interface) -&gt; the missing <code>type</code>s should be traced and added ASAP!</p></li>
<li>
<p>For the following referendums, the <code>votes_*</code> and <code>electorate_*</code> numbers have to be double-checked and possibly corrected since <code>electorate_total &lt; sum(votes_*)</code>, which should by definition be impossible:</p>
<div class="sourceCode" id="cb1"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">rdb</span><span class="fu">::</span><span class="fu"><a href="reference/rfrnds.html">rfrnds</a></span><span class="op">(</span><span class="op">)</span> <span class="op">%&gt;%</span></span>
<span>  <span class="fu">rdb</span><span class="fu">::</span><span class="fu"><a href="reference/add_turnout.html">add_turnout</a></span><span class="op">(</span>excl_dubious <span class="op">=</span> <span class="cn">FALSE</span><span class="op">)</span> <span class="op">%&gt;%</span></span>
<span>  <span class="fu">dplyr</span><span class="fu">::</span><span class="fu"><a href="https://dplyr.tidyverse.org/reference/filter.html" class="external-link">filter</a></span><span class="op">(</span><span class="va">turnout</span> <span class="op">&gt;</span> <span class="fl">1.0</span><span class="op">)</span> <span class="op">%&gt;%</span></span>
<span>  <span class="fu">dplyr</span><span class="fu">::</span><span class="fu"><a href="https://dplyr.tidyverse.org/reference/select.html" class="external-link">select</a></span><span class="op">(</span><span class="va">id</span>, <span class="va">electorate_total</span>, <span class="fu">matches</span><span class="op">(</span><span class="st">"^votes_(yes|no|empty|invalid)"</span><span class="op">)</span>, <span class="va">turnout</span><span class="op">)</span></span></code></pre></div>
<p>We should probably also double-check improbably high turnout numbers, e.g. those &gt; 0.9:</p>
<div class="sourceCode" id="cb2"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">rdb</span><span class="fu">::</span><span class="fu"><a href="reference/rfrnds.html">rfrnds</a></span><span class="op">(</span><span class="op">)</span> <span class="op">%&gt;%</span></span>
<span>  <span class="fu">rdb</span><span class="fu">::</span><span class="fu"><a href="reference/add_turnout.html">add_turnout</a></span><span class="op">(</span>excl_dubious <span class="op">=</span> <span class="cn">FALSE</span><span class="op">)</span> <span class="op">%&gt;%</span></span>
<span>  <span class="fu">dplyr</span><span class="fu">::</span><span class="fu"><a href="https://dplyr.tidyverse.org/reference/filter.html" class="external-link">filter</a></span><span class="op">(</span><span class="fu">dplyr</span><span class="fu">::</span><span class="fu"><a href="https://dplyr.tidyverse.org/reference/between.html" class="external-link">between</a></span><span class="op">(</span><span class="va">turnout</span>, <span class="fl">0.9</span>, <span class="fl">1.0</span><span class="op">)</span><span class="op">)</span> <span class="op">%&gt;%</span></span>
<span>  <span class="fu">dplyr</span><span class="fu">::</span><span class="fu"><a href="https://dplyr.tidyverse.org/reference/select.html" class="external-link">select</a></span><span class="op">(</span><span class="va">id</span>, <span class="va">electorate_total</span>, <span class="fu">matches</span><span class="op">(</span><span class="st">"^votes_(yes|no|empty|invalid)"</span><span class="op">)</span>, <span class="va">turnout</span><span class="op">)</span></span></code></pre></div>
</li>
<li>
<p>Complete and add <a href="https://docs.google.com/spreadsheets/d/108CXVcVISDb8Z9R_fn7S82brXOE8dfIY0VKp3QTc0uU/" class="external-link">Aargau cantonal referendums 1888–1971</a> once <a href="https://github.com/ccmdesign/c2d-app/issues/29" class="external-link">issue #29</a> is resolved.</p>
<p>Also add the referendums from the <a href="https://drive.google.com/drive/folders/1tZVg-ZQ8bi6KeSyofzngV2Qq3LNfE6Rc" class="external-link">similar Excel sheets for the remaining 25 cantons we got</a>. See the <a href="~/Arbeit/ZDA/Lokal/Projekte/HLS/hls_r_project">HLS R project</a> for some partial data cleansing/tidying.</p>
</li>
<li><p>Voting with <code>id == "5bbbfee992a21351232e4f37"</code> (Romania 2008-02-01) was limited to the region <a href="https://en.wikipedia.org/wiki/Sz%C3%A9kely_Land" class="external-link">Szeklerland</a>, therefore <code>subnational_entity</code> should be set to <code>Székely Land</code></p></li>
<li><p>Sobald via Admin-Interface <a href="https://github.com/ccmdesign/c2d-app/issues/27" class="external-link">nach Draft-Status gefiltert werden kann</a>, sollten die existierenden Drafts geprüft werden -&gt; entweder vervollständigen und freischalten oder löschen!</p></li>
<li>
<p>Clean <code>id_official</code>; there are likely erroneous entries or ones that don’t designate an <code>id_official</code> but another kind of ID; entries to double-check:</p>
<div class="sourceCode" id="cb3"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">rdb</span><span class="fu">::</span><span class="fu"><a href="reference/rfrnds.html">rfrnds</a></span><span class="op">(</span><span class="op">)</span> <span class="op">%&gt;%</span> <span class="fu">dplyr</span><span class="fu">::</span><span class="fu"><a href="https://dplyr.tidyverse.org/reference/filter.html" class="external-link">filter</a></span><span class="op">(</span><span class="fu">stringr</span><span class="fu">::</span><span class="fu"><a href="https://stringr.tidyverse.org/reference/str_detect.html" class="external-link">str_detect</a></span><span class="op">(</span>string <span class="op">=</span> <span class="va">id_official</span>, pattern <span class="op">=</span> <span class="st">"\\D"</span><span class="op">)</span> <span class="op">|</span> <span class="op">!</span><span class="op">(</span><span class="va">country_code</span> <span class="op">==</span> <span class="st">"CH"</span> <span class="op">&amp;</span> <span class="va">level</span> <span class="op">==</span> <span class="st">"national"</span><span class="op">)</span> <span class="op">&amp;</span> <span class="op">!</span><span class="fu"><a href="https://rdrr.io/r/base/NA.html" class="external-link">is.na</a></span><span class="op">(</span><span class="va">id_official</span><span class="op">)</span><span class="op">)</span></span></code></pre></div>
<p>Plus: Nobody knows what <code>id_official = "0"</code> means, so it should be replaced with <code>NA</code> (if no proper <code>id_official</code> can be determined).</p>
</li>
<li>
<p><strong><code>municipality</code></strong> scheint inkonsistent zugewiesen; enthält Werte, die klar eine Gemeinde bezeichnen (bspw. <code>"London"</code>), aber auch solche wie <a href="https://de.wikipedia.org/wiki/Republik_Serbische_Krajina" class="external-link"><code>"Republic of Serbian Krajina until 1991"</code></a> oder <a href="https://de.wikipedia.org/wiki/Sozialistische_F%C3%B6derative_Republik_Jugoslawien#Sozialistische_F%C3%B6derative_Republik_Jugoslawien_(1963%E2%80%931992)" class="external-link"><code>Republic of Serbian People (1963-1992)</code></a>… bei letzteren sollte</p>
<ul><li>der passende <a href="https://en.wikipedia.org/wiki/ISO_3166-3#Current_codes" class="external-link"><code>country_code_historical</code> für “Yugoslavia”</a> gesetzt werden</li>
<li>der <code>country_code = "CS"</code> für den Folgestaat “Serbia and Montenegro” gesetzt werden (oder besser leer lassen? TBD!)</li>
<li>
<code>is_past_jurisdiction = TRUE</code> gesetzt werden</li>
<li>den gegenwärtigen Wert in <code>municipality</code> stattdessen in <code>subnational_entity_name</code> eintragen</li>
</ul></li>
<li>
<p>Die Abstimmungen <em>Netherlands 2005-04-08</em> und <em>2014-12-17</em> fanden genau genommen auf <a href="https://de.wikipedia.org/wiki/Sint_Eustatius" class="external-link">Sint Eustatius</a> statt, siehe sudd.ch-Einträge (<a href="https://sudd.ch/event.php?id=an022005" class="external-link">1</a>, <a href="https://sudd.ch/event.php?id=bq012014" class="external-link">2</a>); Sint Eustatius ist zwar eine <a href="https://de.wikipedia.org/wiki/Karibische_Niederlande" class="external-link">Besondere Gemeinde der Niederlande</a>, besitzt aber einen eigenen ISO-Ländercode (BQ-SE) etc.</p>
<p>Sollte daher als <code>country_name</code> nicht besser <em>Sint Eustatius</em> eingetragen werden? Andernfalls sollte <code>subnational_entity</code> auf <code>"Sint Eustatius"</code> gesetzt werden, da ja nicht die gesamte Niederlande abstimmen konnte!</p>
</li>
<li><p>Die Abstimmungen <em>France 2006-02-23</em> und <em>2006-09-06</em> beziehen sich auf Referenden in <a href="https://de.wikipedia.org/wiki/Sark" class="external-link">Sark</a>, <code>country_name</code> sollte daher auf <code>"United Kingdom"</code> oder (besser?) <a href="https://de.wikipedia.org/wiki/Sark#Gesetzgebung_und_Autonomie" class="external-link"><code>"Guernsey"</code></a> gesetzt werden und <code>subnational_entity = "Sark"</code>!</p></li>
<li>
<p>Regarding data about subnational referendums in the US, we currently know of two up-to-date compilations:</p>
<ul><li><p><a href="https://secure.wikimedia.org/wikipedia/en/w/index.php?title=Special:Search&amp;search=Ballotpedia" class="external-link">Ballotpedia</a> maintains a <a href="https://ballotpedia.org/List_of_veto_referendum_ballot_measures" class="external-link">List of veto referendum ballot measures</a>, seems to be very rich in information.</p></li>
<li><p>The <em>National Conference of State Legislatures (NCSL)</em> maintains a <a href="https://www.ncsl.org/research/elections-and-campaigns/ballot-measures-database.aspx" class="external-link">Statewide Ballot Measures Database</a> that “includes all statewide ballot measures in the 50 states and the District of Columbia, starting over a century ago”. It’s unclear (to me) what data this database exactly includes, but it might also be a viable avenue for automated additions to our database.</p></li>
</ul><p>The NCSL also provides information about the <em>institutional</em> conditions regarding direct democracy in the US states, e.g. <a href="https://www.ncsl.org/research/elections-and-campaigns/chart-of-the-initiative-states.aspx" class="external-link">here</a>. Also very rich is the information that Wikipedia provides in the article <a href="https://en.wikipedia.org/wiki/Initiatives_and_referendums_in_the_United_States" class="external-link"><em>Initiatives and referendums in the United States</em></a></p>
</li>
</ul></div>
</div>
<div class="section level3">
<h3 id="validation">Validation<a class="anchor" aria-label="anchor" href="#validation"></a></h3>
<ul><li><p>Systematically inspect/handle all <code>applicability_constraint</code> violations (see <code>validate_rfrnds(check_applicability_constraint = TRUE)</code>).</p></li>
<li>
<p>Systematically check if variables that are “completely dependent” on other variables (like <code>inst_trigger_actor</code> on <code>inst_trigger_type</code>) are correctly filled.</p>
<p>E.g. is <code>inst_trigger_type</code> missing for referendums with IDs <code>5cb82f07cb48652399618eb1</code> and <code>6080ef7d4132d76d38bfe9e0</code> although <code>inst_trigger_actor</code> is present!</p>
<p>If the “completely dependent” property of these variables really holds, we should auto-fill them in the back-end and avoid the possibility of manual changes.</p>
</li>
<li>
<p>Systematically check if all votes in the <code>sudd.ch</code> database are included in the RDB -&gt; parse <code>https://sudd.ch/list.php?mode=allrefs</code> (the <code>id_sudd</code> is part of the link in the last column)</p>
<p>A challenge is to identify the bogus referendums included on sudd.ch like <a href="https://sudd.ch/event.php?id=mb011902" class="external-link">this one</a> (totally fabricated by <a href="https://de.wikipedia.org/wiki/Maghrebinische_Geschichten" class="external-link">Gregor von Rezzori</a>)</p>
</li>
<li><p>According to the guidelines in <code>~/Arbeit/ZDA/Lokal/RDB/Materialen von Mayowa/CH_Vorgehen_Abstimmungseingabe.docx</code>, the PDF <code>files</code> of <code>country_code == "CH"</code> entries must be named consistently <code>Voting_brochure_CH/Kantonskürzel_Jahr_Monat_Tag</code> (“Abstimmungsbroschüre”“) and <code>Results_CH/Kantonskürzel_Jahr_Monat_Tag</code> (results) -&gt; check if this is actually always the case!</p></li>
<li>
<p>check <code>country_code</code> for obsolete codes, i.e. check if</p>
<div class="sourceCode" id="cb4"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span><span class="fu">ISOcodes</span><span class="fu">::</span><span class="va"><a href="https://rdrr.io/pkg/ISOcodes/man/ISO_3166.html" class="external-link">ISO_3166_3</a></span><span class="op">$</span><span class="va">Alpha_4</span> <span class="op">%&gt;%</span></span>
<span>  <span class="co"># exclude simple renamings where `country_code` didn't change</span></span>
<span>  <span class="fu">magrittr</span><span class="fu">::</span><span class="fu"><a href="https://magrittr.tidyverse.org/reference/aliases.html" class="external-link">extract</a></span><span class="op">(</span><span class="fu">stringr</span><span class="fu">::</span><span class="fu"><a href="https://stringr.tidyverse.org/reference/str_sub.html" class="external-link">str_sub</a></span><span class="op">(</span>string <span class="op">=</span> <span class="va">.</span>, start <span class="op">=</span> <span class="fl">3L</span><span class="op">)</span> <span class="op">!=</span> <span class="st">"AA"</span><span class="op">)</span> <span class="op">%&gt;%</span></span>
<span>  <span class="co"># extract former `country_code`</span></span>
<span>  <span class="fu">stringr</span><span class="fu">::</span><span class="fu"><a href="https://stringr.tidyverse.org/reference/str_sub.html" class="external-link">str_sub</a></span><span class="op">(</span>end <span class="op">=</span> <span class="fl">2L</span><span class="op">)</span> <span class="op">%&gt;%</span></span>
<span>  <span class="co"># check</span></span>
<span>  <span class="fu">magrittr</span><span class="fu">::</span><span class="fu"><a href="https://magrittr.tidyverse.org/reference/aliases.html" class="external-link">is_in</a></span><span class="op">(</span><span class="va">data2</span><span class="op">$</span><span class="va">country_code</span><span class="op">)</span> <span class="op">%&gt;%</span></span>
<span>  <span class="fu"><a href="https://rdrr.io/r/base/any.html" class="external-link">any</a></span><span class="op">(</span><span class="op">)</span></span></code></pre></div>
<p>and if so, assign <code>country_code_historical</code>, set <code>is_past_jurisdiction = TRUE</code> and assign proper new <code>country_code</code> (<code>ISOcodes::ISO_3166_3$Alpha_4 %&gt;% stringr::str_sub(start = 3L)</code>; if it’s <code>"HH"</code>, a “manual” decision about which successor country we shall assign has to be hard-coded)`</p>
</li>
<li><p>check <code>electorate_abroad</code> for obvious errors (e.g. <code>id == "5f99b6c8d1291cc3961f1c2c"</code> is one)</p></li>
</ul></div>
<div class="section level3">
<h3 id="miscellaneous">Miscellaneous<a class="anchor" aria-label="anchor" href="#miscellaneous"></a></h3>
<ul><li><p>Die Datenbank braucht ein Logo! (Dann könnten auch passende Favicons <a href="https://realfavicongenerator.net/" class="external-link">generiert werden</a>!)</p></li>
<li>
<p>Harvard Dataverse näher anschauen (Uwe meint, die RDB dort “aufzunehmen”, könnte passen) und vergleichen mit <a href="https://zenodo.org/" class="external-link">Zenodo</a> (siehe FA-Notizen) und <a href="https://datahub.io/" class="external-link">Datahub</a>.</p>
<p>Abklären:</p>
<ul><li><p><em>Lizenzanforderungen?</em> Default für Uploads ist CC0, aber es kann eine abweichende Lizenz definiert werden (es finden sich Beispiele mit ODbL 1.0!); darüber hinaus gelten nicht-rechtlich-bindende <a href="https://dataverse.org/best-practices/dataverse-community-norms" class="external-link"><em>community norms</em></a> (viel besserer Ansatz als in FORSbase!)</p></li>
<li><p>Datensätze tatsächlich hinterlegt oder nur Referenzen?</p></li>
</ul></li>
<li><p>Der C2D-Link auf der <a href="https://www.zdaarau.ch/en/applications" class="external-link">ZDA-Webseite</a> sollte auf HTTP<strong>S</strong> geändert werden!</p></li>
<li>
<p>IT-Firmen, die als Nachfolge für CCM Design möglicherweise in Frage kommen:</p>
<ul><li>
<a href="https://furqansoftware.com/" class="external-link">Furqan Software</a>; founder <a href="https://github.com/hjr265" class="external-link">Mahmud Ridwan</a> developed two notable Goldmark extensions, <a href="https://github.com/FurqanSoftware/goldmark-d2" class="external-link">goldmark-d2</a> and <a href="https://github.com/FurqanSoftware/goldmark-katex" class="external-link">goldmark-katex</a>, which <a href="https://hjr265.me/open-source/" class="external-link">i.a. other notable activity</a> proves he deeply understands how open source is best organized and engineered!</li>
<li>
<a href="https://techhub.p-m.si/" class="external-link">PM TechHub</a>, Slowenien: Für den Neubau der <code>rdb.vote</code>-Hauptseite. Sie sind JAMStack-Profis und <a href="https://techhub.p-m.si/insights/introducing-decap-cms/" class="external-link">Maintainer des Git-basierten CMS <em>Decap</em></a>.</li>
<li>
<a href="https://www.brudi.com/" class="external-link">Brudi</a>, Zürich</li>
<li>
<a href="https://cloud68.co/" class="external-link">Cloud68</a>, Estland</li>
<li>
<a href="https://www.liip.ch/" class="external-link">Liip</a>, Zürich (und weitere CH-Städte)</li>
<li>
<a href="https://opsone.ch/" class="external-link">Ops One</a>, Zürich</li>
</ul></li>
</ul></div>
<div class="section level3">
<h3 id="open-questions--suggestions">Open questions / suggestions<a class="anchor" aria-label="anchor" href="#open-questions--suggestions"></a></h3>
<div class="section level4">
<h4 id="mit-irina-besprechen">Mit Irina besprechen<a class="anchor" aria-label="anchor" href="#mit-irina-besprechen"></a></h4>
<ul><li><p>Kann mir jemand die genaue Bedeutung von <code>inst_object_revision_extent</code> sowie den <code>*precondition*</code>-Variablen erklären (insb. aus <code>inst_precondition_decision</code> werde ich nicht schlau…)?</p></li>
<li>
<p>Stimmen die Definitionen im Codebook so? Insb.:</p>
<ul><li><code>committee_name</code></li>
<li>
<code>type</code> und alle <code>inst_*</code>-Variablen</li>
</ul></li>
<li><p><code>inst_quorum_turnout</code> sollte standardisiert werden -&gt; was wäre eine geeignete, abschliessende Menge an Werten?</p></li>
<li>
<p><code>inst_object_legal_level</code> sollte m. E. in Relation zu <code>level</code> stehen, tut es aber nicht. Dementsprechend kann <code>inst_object_legal_level</code> mehrdeutig sein (Beispiel: Ist <code>inst_object_legal_level = "law"</code> lokales, kantonales oder nationales Recht bei Referendum auf CH-Gemeindeebene?)</p>
<p>Wir sollten das daher ändern (sprich auf <em>eindeutige</em> Weise erfassen. Vorschläge?</p>
<p>Würde dieses Problem behoben, könnte <code>inst_object_legal_level</code> vermutlich auch als <code>ordinal_ascending</code> klassifiziert werden.</p>
</li>
<li>
<p>Ist <code>position_government</code> (ehemals <code>recommendation</code>) immer die Empfehlung der Regierung? Oder immer des Parlamentes? Oder manchmal dies, manchmal jenes?</p>
<p>Zudem: Die Variable kennt gegenwärtig eig. 3 Ausprägungen, ich behandle den Wert <code>"None"</code> allerdings als <code>NA</code>, weil das gegenwärtige <a href="https://admin.c2d.ch/" class="external-link">Admin-Portal</a> keine <code>NA</code>s zulässt, sprich die Coder bei Unbekanntheit des Wertes gezwungen sind, <code>"None"</code> anzugeben. Wie siehst du das?</p>
</li>
<li>
<p>Currently, <code>inst_trigger_threshold</code> is a free text field which is really bad for analysis since no coding consistency at all is enforced. Instead, we should define, in what way the same information could be captured in a more systematic way (splitting it into two vars <code>inst_trigger_threshold_relative</code> and <code>inst_trigger_threshold_absolute</code> might make sense), introduce the new variable and then convert the old values to the new format.</p>
<p>Was meint Irina?</p>
</li>
</ul></div>
</div>
</div>
<div class="section level2">
<h2 id="obsolete-referring-to-old-ccm-design-infrastructure-which-is-to-be-replaced">Obsolete (referring to old CCM-Design infrastructure which is to be replaced)<a class="anchor" aria-label="anchor" href="#obsolete-referring-to-old-ccm-design-infrastructure-which-is-to-be-replaced"></a></h2>
<ul><li>
<p>MongoDB/API: Track atomic edit history, traceable by author, and make it visually inspectable (some kind of diff viewer would be cool). On top of this, some method to easily undo specific or all edits by a specific user account should be added.</p>
<p>See <a href="https://github.com/ccmdesign/c2d-app/issues/34" class="external-link">issue #34</a> (point 3) for a tentative request and <a href="https://github.com/ccmdesign/c2d-app/issues/34#issuecomment-852566636" class="external-link">@liviass’ answer</a> about an already existing events collection (with no API endpoint so far).</p>
</li>
<li>
<p>MongoDB: optimize order of subvariables (<code>files</code> and <code>context.votes_per_canton</code>); doing this post-hoc in R is slow/inefficient, so getting the JSON in the desired order directly from the API would be cool…</p>
<p>but is this actually possible? generally, the order of variables in the returned JSON seems random: compare e.g. <code>date</code> of <a href="https://services.c2d.ch/referendums/6102ae4ec72633da60229941" class="external-link">here</a> vs. <a href="https://services.c2d.ch/referendums/604b33cb4132d76d38bfe97b" class="external-link">here</a></p>
</li>
<li><p>C2D Website: Ditch the <code>by ccm.design</code> promo in the footer?## Reported to <a href="https://github.com/ccmdesign/c2d-app/issues/" class="external-link">CCM Design</a></p></li>
<li>
<p>Publish code under AGPL &gt;= 3, see <a href="https://github.com/ccmdesign/c2d-app/issues/26" class="external-link">issue #26</a></p>
<p>We should then make the repository public!</p>
</li>
<li><p>C2D Admin Front-end: Add possibility to filter by draft status (binary) and color draft rows (e.g. in orange) -&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/27" class="external-link">issue #26</a></p></li>
<li>
<p>C2D Website: Lizenzierung der Daten fehlt (betrifft auch den Download via rdb-Paket)! <a href="https://opendatacommons.org/licenses/odbl/summary/" class="external-link">ODC-ODbL</a> würde sich anbieten. -&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/37" class="external-link">issue #37</a></p>
<p>Once this is implemented, the same license terms should be added to the rdb package documentation!</p>
</li>
<li><p>Introduce <code>date_time_last_edited</code> holding the timestamp of a referendum entry’s last edit. -&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/29" class="external-link">issue #29</a></p></li>
<li><p>Add <code>id_official</code> and <code>id_sudd</code>! Then I can populate them with the (corrected) data from the former <code>number</code> variable and <code>number</code> can be deleted. -&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/29" class="external-link">issue #29</a></p></li>
<li>
<p>Introduce <code>subnational_entity_code</code>; <a href="https://en.wikipedia.org/wiki/ISO_3166-2" class="external-link">ISO 3166-2</a> codes seem perfectly suitable</p>
<p>open points:</p>
<ul><li><p>we need to establish a policy on which <code>country_code</code> to assign to <a href="https://en.wikipedia.org/wiki/ISO_3166-2#Subdivisions_included_in_ISO_3166-1" class="external-link">subnational entitites that have both an ISO 3166-1 country code as well as an ISO-3166-2 subdivision code</a> (recommended: avoid using the own ISO 3166-1 country code but assign the one from the subdivision’s “parent” country)</p></li>
<li><p>how to deal with subnational entity changes? ISO 3166-2 is regularly updated but there doesn’t seem to exist an equivalent to ISO-3166-3 codes on the subnational level…</p></li>
<li><p>how to deal with “inofficial” / non-authorized subnational entities that don’t have an ISO-3166-2 code?</p></li>
<li><p>(I think introducing dedicated variables to capture the administrative division hierarchy below the national level in a more fine-grained way makes little sense since <a href="https://en.wikipedia.org/wiki/Administrative_division" class="external-link">administrative division levels vary widely across the globe</a>.)</p></li>
</ul><p>-&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/29" class="external-link">issue #29</a></p>
</li>
<li><p>Introduce <code>is_past_jurisdiction</code> signifying if the relevant <a href="https://en.wikipedia.org/wiki/Jurisdiction_(area)" class="external-link">jurisdiction</a> where the referendum took place still exists (<code>FALSE</code>) or not (<code>TRUE</code>) -&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/29" class="external-link">issue #29</a></p></li>
<li><p>Introduce <code>country_code_historical</code> that holds the <a href="https://en.wikipedia.org/wiki/ISO_3166-3" class="external-link">ISO 3166-3</a> code for referendums in countries that don’t exist anymore (see also <a href="https://www.statcan.gc.ca/eng/subjects/standard/sccai/2011/scountry-desc" class="external-link">this site by Statistics Canada</a>; also informative: <a href="https://en.wikipedia.org/wiki/United_Nations_list_of_Non-Self-Governing_Territories" class="external-link uri">https://en.wikipedia.org/wiki/United_Nations_list_of_Non-Self-Governing_Territories</a>); ISO 3166-3 seems to only assign codes for countries that ceased to exist since 1974 -&gt; is there any classification for older historical entities? -&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/29" class="external-link">issue #29</a></p></li>
<li><p>Introduce <code>question</code> holding the referendum question 1:1 as it was asked and <code>question_en</code> containing an English translation; open question: what to do when the question was officially asked in multiple languages like in CH? -&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/29" class="external-link">issue #29</a></p></li>
<li><p>Outsource institutional variables into separate database/MongoDB collection and adapt everything. -&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/42" class="external-link">issue #42</a></p></li>
<li>
<p>Extend the set of variables, so the <code>remarks</code> field isn’t overloaded anymore. Possible extensions (taken from Louis’ <code>remarks</code> structure (cf. <code>~/Arbeit/ZDA/Lokal/RDB/Materialen von Mayowa/Intl_Vorgehen_Abstimmungseingabe.docx</code>)):</p>
<ul class="task-list"><li><label><input type="checkbox">Background information on the vote (most important actors and events (sudd.ch, Wikipedia, NZZ etc.), content/main points)</label></li>
<li><label><input type="checkbox" checked>Voting question; original language</label></li>
<li><label><input type="checkbox" checked>Voting question; English (translation if necessary)</label></li>
<li><label><input type="checkbox">Legal basis</label></li>
<li><label><input type="checkbox">Name of the institution in original language</label></li>
<li><label><input type="checkbox">Specialities of the institution (e.g. special quorum or 2 collecting periods)</label></li>
<li><label><input type="checkbox">Specialities of the result (e.g. contradictory numbers)</label></li>
</ul></li>
<li>
<p><code>topics</code>: Adapt back-end to apply the same 3-tier topics logic that the R package does:</p>
<ul><li>Parent topics should be implicit, i.e. it should be impossible to select a parent topic and one of its respective childs topics at the same time (selecting a child topic should always result in implicit selection of its parent (e.g. in a different (e.g. faded) color)).</li>
<li>The upper limit of 3 topics should refer to <em>main</em> topics (i.e. excluding any implicit parent topics).</li>
<li>Based on the user’s selection of <em>main</em> topics, parent topics should automatically be derived from child topics based on the <a href="https://github.com/ccmdesign/c2d-app/blob/master/ch.c2d.admin/web/themes.json" class="external-link">hierarchical topic structure</a> and all the topics should be assigned to the 3 variables <code>topics_tier_1</code>, <code>topics_tier_2</code>, <code>topics_tier_3</code>.</li>
</ul><p>-&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/41" class="external-link">issue #41</a></p>
</li>
<li>
<p>Standardize <code>subnational_entity_name</code>; <a href="https://www.iso.org/obp/ui/#iso:std:iso:3166:-2:ed-4:v1:en" class="external-link">ISO 3166-2 country subdivision names</a> (definition in chap. 3.29) seem suitable (mapping codes &lt;-&gt; names in R via <code><a href="https://rdrr.io/pkg/ISOcodes/man/ISO_3166.html" class="external-link">ISOcodes::ISO_3166_2</a></code>; note that for some subdivisions, different names exist for multiple languages, e.g. some <a href="https://www.iso.org/obp/ui/#iso:code:3166:CH" class="external-link">Swiss cantons</a>; <code><a href="https://rdrr.io/pkg/ISOcodes/man/ISO_3166.html" class="external-link">ISOcodes::ISO_3166_2</a></code> only tracks one name (the most “native” one per subdivision, I guess))</p>
<p>-&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/44" class="external-link">issue #44</a></p>
</li>
<li>
<p>Rethink standardization of <code>country_name</code>. Current problem: standardization happens only when creating/editing entries. Thus, it’s not consistent, e.g. for <code>country_code == "GB"</code> there are entries from before the relaunch with <code>country_name = "United Kingdom"</code>, and there are newer entries with the auto-deduced <code>country_name = "United Kingdom of Great Britain and Northern Ireland"</code>.</p>
<p>See <a href="https://vincentarelbundock.github.io/countrycode/reference/codelist.html" class="external-link"><code>countrycode::codelist</code></a> for possible standards; <a href="https://en.wikipedia.org/wiki/List_of_ISO_3166_country_codes" class="external-link">ISO 3166 English short country names</a> (<code>countrycode::codelist$iso.name.en</code>) seem most promising.</p>
<p>Ideally, this would be done in the API back-end so <code>country_name</code> is determined at request time if possible.</p>
<p>-&gt; see <a href="https://github.com/ccmdesign/c2d-app/issues/43" class="external-link">issue #43</a> for a closed (and partially invalid) first problem report and <a href="https://github.com/ccmdesign/c2d-app/issues/51" class="external-link">#51</a> for a follow-up requesting an improved UX.</p>
</li>
<li>
<p>Deduplicate file attachments! Currently, file attachments like voting brochures which apply to multiple proposals on the same ballot date are attached to each individual proposal, thus resulting in file duplications. Example: subnational ballot date in ZH, CH @ 2022-05-15 has 4 proposals and the file <code>voting_brochure_zh_2022_05_15_de.pdf</code> is uploaded 4 different times to our Amazon S3 bucket:</p>
<ul><li>
<code>62d6760ca52c3995043a8a1e</code>: <a href="https://services.c2d.ch/s3_objects/referendum_62d6760ca52c3995043a8a1e_0001.pdf" class="external-link uri">https://services.c2d.ch/s3_objects/referendum_62d6760ca52c3995043a8a1e_0001.pdf</a>
</li>
<li>
<code>62d67203a52c3995043a8a16</code>: <a href="https://services.c2d.ch/s3_objects/referendum_62d67203a52c3995043a8a16_0001.pdf" class="external-link uri">https://services.c2d.ch/s3_objects/referendum_62d67203a52c3995043a8a16_0001.pdf</a>
</li>
<li>
<code>62d66e97a52c3995043a8a0f</code>: <a href="https://services.c2d.ch/s3_objects/referendum_62d66e97a52c3995043a8a0f_0001.pdf" class="external-link uri">https://services.c2d.ch/s3_objects/referendum_62d66e97a52c3995043a8a0f_0001.pdf</a>
</li>
<li>
<code>62d66ce0a52c3995043a8a08</code>: <a href="https://services.c2d.ch/s3_objects/referendum_62d66ce0a52c3995043a8a08_0002.pdf" class="external-link uri">https://services.c2d.ch/s3_objects/referendum_62d66ce0a52c3995043a8a08_0002.pdf</a>
</li>
</ul><p>Ideally, we’d have two different attachment types:</p>
<ol style="list-style-type: decimal"><li>Attachments that belong to an individual proposal.</li>
<li>Attachments that belong to a whole ballot date in a jurisdiction, i.e. all proposals at that ballot.</li>
</ol><p>That way uploading <em>and</em> assigning e.g. a voting brochure to referendums would be a <em>single action</em>.</p>
<p>Rough outline of the procedure for introducing the second attachment type:</p>
<ol style="list-style-type: decimal"><li><p>Create new ballot-date-level database with primary key <code>country_code_historical</code>/<code>country_code</code> + <code>subnational_entity_code</code> + <code>municipality</code> + <strong><code>date</code></strong>, plus a field for attachment metadata (to be discussed what exactly is sensible here).</p></li>
<li><p>Create necessary API endpoints and front-end logic for type 2 attachments.</p></li>
<li><p>Treat all existing attachments as belonging to individual proposals (type 1).</p></li>
<li><p>Programmatically identify the attachments that belong to ballot dates (type 2) instead by comparing file hashes (open question: are file hashes already available from S3 some way or do we have to download all attachments and calculate them ourselves?) and convert them to type 2.</p></li>
</ol></li>
<li><p>C2D admin front-end: Louis’ Dokument <code>~/Arbeit/ZDA/Lokal/RDB/Materialen von Mayowa/Intl_Louis/3_Test_Datenbank.docx</code></p></li>
<li><p>C2D website: Möglichkeit zum Report falscher/fehlender Daten schaffen! Bevor CCM Design damit beauftragt wird, sollten wir definieren, wie ungefähr das aussehen soll. Bspw. einfach via HTML-Formular mit geeigneten Feldern (je nach Seite, von dem es aufgerufen wird, bereits vorbefüllt (<code>country_code</code>, <code>level</code>, <code>id</code> etc.))?</p></li>
<li><p>C2D website: The about text should be overhauled.</p></li>
<li><p>C2D website: The listing of referendums should be overhauled. It currently lacks important information, e.g. <code>level</code>.</p></li>
<li><p>Once referendum deletions are possible on production servers, extend tests to modify every single data field individually.</p></li>
<li><p>Once <a href="https://github.com/ccmdesign/c2d-app/issues/82" class="external-link">issue #82</a> is fixed, remove/adapt all remaining code handling <code>country_code_historical</code> and <code>is_past_jurisdiction</code> (especially the sudd.ch-related fns have to be overhauled)</p></li>
<li><p>As soon as <a href="https://github.com/ccmdesign/c2d-app/issues/57" class="external-link">issue #57</a> is resolved, properly process the question variables (and adapt codebook).</p></li>
<li><p>Implement fn to rename file attachments as soon as <a href="https://github.com/ccmdesign/c2d-app/issues/69" class="external-link">issue #69</a> is resolved.</p></li>
</ul></div>
</div>

  </main><aside class="col-md-3"><nav id="toc" aria-label="Table of contents"><h2>On this page</h2>
    </nav></aside></div>


    <footer><div class="pkgdown-footer-left">
  <p>Developed by Salim Brüggemann, Uwe Serdült.</p>
</div>

<div class="pkgdown-footer-right">
  <p>Site built with <a href="https://pkgdown.r-lib.org/" class="external-link">pkgdown</a> 2.1.1.9000.</p>
</div>

    </footer></div>





  </body></html>

